#include <vcl/dstring.h>
#include <dir.h>

class TADAMEm
{
 private:
  AnsiString FReadMeFile;
  AnsiString FADAMEmPath;
  AnsiString FEOSImage;
  AnsiString FWPImage;
  AnsiString FOS7Image;
  AnsiString FStartupDirectory;
  AnsiString FCassetteAImage;
  AnsiString FCassetteBImage;
  AnsiString FDiskAImage;
  AnsiString FDiskBImage;
  AnsiString FDiskCImage;
  AnsiString FDiskDImage;
  AnsiString FCartridgeImage;
  int FVideoMode;
  int FUPeriod;
  int FOverscan;
  int FShowAllSprites;
  int FSoundDevice;
  int FVolume;
  int FSoundQuality;
  int FPanningLevel;
  int FReverbLevel;
  int FChorusLevel;
  int FSpeakerChannelA;
  int FSpeakerChannelB;
  int FSpeakerChannelC;
  int FSpeakerChannelD;
  AnsiString FSoundLog;
  int FEmuMode;
  int FIFreq;
  int FCPUSpeed;
  int FExpansionModule;
  int FExpansionModuleDevice;
  int FSensitivity;
  int FCalibrate;
  int FVerbose;
  int FSync;
  int FPrinterType;
  int FJoystick;
  int FSwapJoystickButtons;
  int FSwapKeyboardButtons;
  int FSwapMouseButtons;
  int FReverseKeypad;
  int FExpansionRAMPages;
  AnsiString FSnapshot;
  AnsiString FParallelLog;
  int FTDOSVideoMode;
  int FPalette;
  int FAutoSnap;
  AnsiString FPrinterLog;
  AnsiString FUserOptions;
  char TempFile[MAXPATH];
 public:
  TADAMEm();
  ~TADAMEm();
  void SetDefaultOptions (void);
  void LoadFromFile (AnsiString&);
  void SaveToFile (AnsiString&);
  AnsiString &GetEmulatorOptions (AnsiString&);
  int Execute (void);
  void SetADAMEmPath(AnsiString&);
  void SetEOSImage(AnsiString&);
  void SetWPImage(AnsiString&);
  void SetOS7Image(AnsiString&);
  void SetStartupDirectory(AnsiString&);
  void SetCassetteAImage(AnsiString&);
  void SetCassetteBImage(AnsiString&);
  void SetDiskAImage(AnsiString&);
  void SetDiskBImage(AnsiString&);
  void SetDiskCImage(AnsiString&);
  void SetDiskDImage(AnsiString&);
  void SetCartridgeImage(AnsiString&);
  void SetVideoMode(int);
  void SetUPeriod(int);
  void SetOverscan(int);
  void SetShowAllSprites(int);
  void SetSoundDevice(int);
  void SetVolume(int);
  void SetSoundQuality(int);
  void SetPanningLevel(int);
  void SetReverbLevel(int);
  void SetChorusLevel(int);
  void SetSpeakerChannelA(int);
  void SetSpeakerChannelB(int);
  void SetSpeakerChannelC(int);
  void SetSpeakerChannelD(int);
  void SetSoundLog(AnsiString&);
  void SetEmuMode(int);
  void SetIFreq(int);
  void SetCPUSpeed(int);
  void SetExpansionModule(int);
  void SetExpansionModuleDevice(int);
  void SetSensitivity(int);
  void SetCalibrate(int);
  void SetVerbose(int);
  void SetSync(int);
  void SetPrinterType(int);
  void SetJoystick(int);
  void SetSwapJoystickButtons(int);
  void SetSwapKeyboardButtons(int);
  void SetSwapMouseButtons(int);
  void SetReverseKeypad(int);
  void SetPrinterLog(AnsiString&);
  void SetUserOptions(AnsiString&);
  void SetExpansionRAMPages (int);
  void SetSnapshot (AnsiString&);
  void SetParallelLog (AnsiString&);
  void SetTDOSVideoMode (int);
  void SetPalette (int);
  void SetAutoSnap (int);
  __property AnsiString ADAMEmPath = { read=FADAMEmPath ,write=SetADAMEmPath };
  __property AnsiString EOSImage = { read=FEOSImage ,write=SetEOSImage };
  __property AnsiString WPImage = { read=FWPImage ,write=SetWPImage };
  __property AnsiString OS7Image = { read=FOS7Image ,write=SetOS7Image };
  __property AnsiString StartupDirectory = { read=FStartupDirectory ,write=SetStartupDirectory };
  __property AnsiString CassetteAImage = { read=FCassetteAImage ,write=SetCassetteAImage };
  __property AnsiString CassetteBImage = { read=FCassetteBImage ,write=SetCassetteBImage };
  __property AnsiString DiskAImage = { read=FDiskAImage ,write=SetDiskAImage };
  __property AnsiString DiskBImage = { read=FDiskBImage ,write=SetDiskBImage };
  __property AnsiString DiskCImage = { read=FDiskCImage ,write=SetDiskCImage };
  __property AnsiString DiskDImage = { read=FDiskDImage ,write=SetDiskDImage };
  __property AnsiString CartridgeImage = { read=FCartridgeImage ,write=SetCartridgeImage };
  __property int VideoMode = { read=FVideoMode ,write=SetVideoMode };
  __property int UPeriod = { read=FUPeriod ,write=SetUPeriod };
  __property int Overscan = { read=FOverscan ,write=SetOverscan };
  __property int ShowAllSprites = { read=FShowAllSprites ,write=SetShowAllSprites };
  __property int SoundDevice = { read=FSoundDevice ,write=SetSoundDevice };
  __property int Volume = { read=FVolume ,write=SetVolume };
  __property int SoundQuality = { read=FSoundQuality ,write=SetSoundQuality };
  __property int PanningLevel = { read=FPanningLevel ,write=SetPanningLevel };
  __property int ReverbLevel = { read=FReverbLevel ,write=SetReverbLevel };
  __property int ChorusLevel = { read=FChorusLevel ,write=SetChorusLevel };
  __property int SpeakerChannelA = { read=FSpeakerChannelA ,write=SetSpeakerChannelA };
  __property int SpeakerChannelB = { read=FSpeakerChannelB ,write=SetSpeakerChannelB };
  __property int SpeakerChannelC = { read=FSpeakerChannelC ,write=SetSpeakerChannelC };
  __property int SpeakerChannelD = { read=FSpeakerChannelD ,write=SetSpeakerChannelD };
  __property AnsiString SoundLog = { read=FSoundLog ,write=SetSoundLog };
  __property int EmuMode = { read=FEmuMode ,write=SetEmuMode };
  __property int IFreq = { read=FIFreq ,write=SetIFreq };
  __property int CPUSpeed = { read=FCPUSpeed ,write=SetCPUSpeed };
  __property int ExpansionModule = { read=FExpansionModule ,write=SetExpansionModule };
  __property int ExpansionModuleDevice = { read=FExpansionModuleDevice ,write=SetExpansionModuleDevice };
  __property int Sensitivity = { read=FSensitivity ,write=SetSensitivity };
  __property int Calibrate = { read=FCalibrate ,write=SetCalibrate };
  __property int Verbose = { read=FVerbose ,write=SetVerbose };
  __property int Sync = { read=FSync ,write=SetSync };
  __property int PrinterType = { read=FPrinterType ,write=SetPrinterType };
  __property int Joystick = { read=FJoystick ,write=SetJoystick };
  __property int SwapJoystickButtons = { read=FSwapJoystickButtons ,write=SetSwapJoystickButtons };
  __property int SwapKeyboardButtons = { read=FSwapKeyboardButtons ,write=SetSwapKeyboardButtons };
  __property int SwapMouseButtons = { read=FSwapMouseButtons ,write=SetSwapMouseButtons };
  __property int ReverseKeypad = { read=FReverseKeypad ,write=SetReverseKeypad };
  __property AnsiString PrinterLog = { read=FPrinterLog ,write=SetPrinterLog };
  __property AnsiString UserOptions = { read=FUserOptions ,write=SetUserOptions };
  __property AnsiString ReadMeFile = { read=FReadMeFile };
  __property int ExpansionRAMPages = { read=FExpansionRAMPages ,write=SetExpansionRAMPages };
  __property AnsiString Snapshot = { read=FSnapshot ,write=SetSnapshot };
  __property AnsiString ParallelLog = { read=FParallelLog ,write=SetParallelLog };
  __property int TDOSVideoMode = { read=FTDOSVideoMode ,write=SetTDOSVideoMode };
  __property int Palette = { read=FPalette ,write=SetPalette };
  __property int AutoSnap = { read=FAutoSnap ,write=SetAutoSnap };
};

